; CODE RED!
; Adventure Vision Demo by AV DEV TEAM 2013 of MEGA
;
; CODE & GFX by Mr. Blinky, dndn1011, sy2002, JAC, Wa & pop
; MUSIC by Skyrunner
; DEVTOOLS by JustBurn

;Note this version has the small audio glitch removed that was
;hearable in the video recording that was made for revision 2013

.set	CODERED_ASM,	1
.set 	LOOPDEMO,		1	;remark this line to create video version that ends with an explosion

;demo ends with crash loop sound (see bg_break in bgcode.asm)

;Memory MAP:
;---------------------------------------

;Page:	Description:

;00	BIOS
;01	main code
;02	main code
;03	SCROLLY TEXT (fixed location reserved for text)
;04	FONT + JAC's CHECKERS P1
;05	SCROLLY CODE
;06	SOUND DATA + JAC's CHECKERS P2
;07	BOOBIEGIRL DIM IMAGES + BNP UNPACK
;08	BOOBIEGIRL BRIGHT IMAGES
;09	TWISTER PART 1/2
;0A	TWISTER PART 2/2
;0B	DINO's PLOT and LINE
;0C DINO's TRANSFORM, STARS, MESH + MEGA ZOOMER DIV16
;0D DINO's STUFF + MEGA ZOOMER: ARTWORK & SCENE #6 SEQUENCER
;0E MEGA ZOOMER
;0F MEGA ZOOMER

;RAM MAP:
;---------------------------------------

;- Dino's part internal RAM usage -
.equ   mesh_temp,$20
.equ   transform_temp,$20
.equ   transform_spin,$21

.equ   mesh_select,$24 ;\do not change order
;.equ   temp_framecount,$25
;.equ   temp_effectcount,$26

;.equ   plot_temp1,$22			;\do not change order
;.equ   plot_temp2,$23			;/

.equ   rtab, $24 ; 6 bytes in rng plus workspace

.equ	IRAM_3DOBJECT, $2E
;- twister (local, may be used by other demo parts) -
.equ	IRAM_TWISTSTEP,		$2E	;\
.equ	IRAM_TWISTPOS,		$2F	; | do not change order
.equ	IRAM_TWISTSTEPH,	$30	; |
.equ	IRAM_TWISTPOSH,		$31	;/

;!!! GLOBAL IRAM do not use in demo parts unless backuped !!!

;- scrolly (global) -
.equ	IRAM_CHCNT,			$32		;\character width counter
.equ	IRAM_PCHAR,			$33		;|pointer to current font character row
.equ	IRAM_PTEXT,			$34		;/pointer to current text character of message
.EQU	IRAM_SCROW, 		$35		;\scrolly display start row
.equ	IRAM_WTPOS,			$36		;|sine table pointer
.equ	IRAM_WTPSV,			$37		;/sine table pointer backup
.equ	IRAM_SCPOS,			$38		;scrolly Y position

;- sound (global) -
.equ	M_SONG_POS,			$39	;song position       \  do not changer order
.equ	M_PLAY_CTR,			$3A	;global state counter/ 
.equ    M_PLAY_CMD,			$3B

;- megabios (global) -
.equ	IRAM_DSPOS,			$3C ;display position for transition
.equ	IRAM_DSPMODE,		$3D	;global display mode 
.equ	IRAM_FRAMES,		$3E	;Frame counter LSB       
.equ	IRAM_FRAMES_MSB,	$3F	;Frame counter MSB       
;---------------------------------------

	.include "includes\mc8048.asm"
	
	.org	$000

	.include "includes\megabios.asm"

	;.org	$100
	
start:
	
	;//// Script-Scene #0 ////////////////////////////////////////////
	;//// STARTUP DELAY ////////////////////////////////////////////

	call AV_SHOWWAIT2	; wait 2 seconds
	
	;jmp twister_part ;meshinit
			
	;//// Script-Scene #1 ////////////////////////////////////////////
	;//// MEGA-LOGO opening and closing slowly ///////////////////////
	
	; MEGA-ZOOMER: Initialize
	;sel rb1				; r7 must be in rb1; rb1 already active due to above code
	;mov r7, <megalogo		; select the megalogo
	call mz_init_mega		; returns in rb0
		
	; set effect parameters
	clr a
	mov r0, IRAM_MZ_XPOS
	mov @r0, a				; start x
	inc r0					; IRAM_MZ_YPOS
	mov @r0, 12				; start y
	mov r0, MZ_ALLOW_XY
	mov @r0, %10000001		; no movement
	inc r0					; MZ_ALLOW_DX
	mov @r0, 49				; no zoom, but fixed width
	inc r0					; MZ_ALLOW_DY
	mov @r0, a				; open/close logo on y-axis
	inc r0					; MZ_TOGGLE_DELAY
	mov @r0, 3 * FPS		; wait 3 sec between opening and closing the logo
	inc r0					; MZ_STARS
	mov @r0, a				; no stars

	; execute the effect
	mov	a,  (-139-5) & $FF
	call mz_run
	
	; clear screen and 2 seconds delay
	call AV_CLS_VRAM3
	call AV_SHOWWAIT2
	
	;//// Script-Scene #2 ////////////////////////////////////////////
	;//// INTRO-SCROLLY //////////////////////////////////////////////

	mov	a,SC_MSG01 & $FF
	mov r1,SM_MOVEOFF+SM_SINEOFF+16
	call initscrolly
	
	mov	a,256-15*FPS
	call AV_SETTRIGGER1
inf:
	call cls
	call showscrolly
	call AV_SHOW
	jc inf
	
	;//// Script-Scene #3 ////////////////////////////////////////////
	;//// CODERED LOGO moving x-axis /////////////////////////////////
	
	; MEGA-ZOOMER: Initialize
	;sel rb1				; r7 must be in rb1; rb1 already active due to above code
	mov r7, <coderedlogo	; select the megalogo
	call mz_init
		
	; set effect parameters
	clr a
	mov r0, IRAM_MZ_XPOS
	mov @r0, 4				; start x
	inc r0					; IRAM_MZ_YPOS
	mov @r0, 12				; start y
	mov r0, MZ_ALLOW_XY
	mov @r0, %10000001		; no movement
	inc r0					; MZ_ALLOW_DX
	mov @r0, a				; zoom dx, i.e. roll-in
	inc r0					; MZ_ALLOW_DY
	mov @r0, 9				; no zoom, but fixed height
	inc r0					; MZ_TOGGLE_DELAY
	mov @r0, a				; no delay
	inc r0					; MZ_STARS
	mov @r0, a				; no stars

	; execute the effect
	mov	a,  -49 & $FF
	call mz_run
    call scene_3_contd
	jmp checkers_part1
	
scene_3_contd:
	mov r0, MZ_ALLOW_XY
	mov @r0, %00000001		; allow x-movement
	inc r0
	mov @r0, 49				; stop x-zooming
	
	mov	a,  -7 * FPS & $FF
		
mz_run:	
	call AV_SETTRIGGER1
mz_run2:	
	sel mb1		
	call mz_runeffect
	sel mb0
	ret
		
	;//// Script-Scene #4 ////////////////////////////////////////////
	;//// CHECKERBOARD mutation //////////////////////////////////////

checkers_part1:
	mov a,SC_MSG03 & $FF
	mov	r1,SM_MOVEOFF+SM_SINEOFF+4 ;20
	call checkers_zoom

	;//// Script-Scene #5 ////////////////////////////////////////////
	;//// STARFIELD //////////////////////////////////////////////////

.equ	STARS_FRAMES, -16*FPS
.equ	STARS_SCROLLY_FRAMES,-STARS_FRAMES-5

	mov a,<SC_MSG04
	mov	r1,SM_MOVEON+SM_SINEOFF+16
	call initscrolly
	
	; MEGA-ZOOMER: Initialize it already here, so that the transition
	; between Scene #5 and Scene #6 is seamless
	;sel rb1				; r7 must be in rb1; rb1 already active due to above code
	;mov r7, <megalogo
	call mz_init_mega

	mov	a, STARS_FRAMES & $FF
	;mov r1,STARS_FRAMES >> 8
	call	AV_SETTRIGGER1
	;	mov r1, 25
	;	mov r2, 20
	call init_dndn_stars

starloop:
	call AV_CLS_VRAM3
;	mov r2,<STARS_SCROLLY_FRAMES
;	mov r1,>STARS_SCROLLY_FRAMES
;	call AV_TESTTRIGGER2
;	jc star_noscrolly
	call showscrolly
	
star_noscrolly:	
	clr a					; STARS_LINEAR == 0
	sel mb1
	call draw_dndn_stars
	sel mb0
	call AV_SHOW_VRAM3
	jc	starloop

	;//// Script-Scene #6 ////////////////////////////////////////////
	;//// MEGA-ZOOMER plus STARFIELD (plus sequenced variations) /////
		
	call scene_6

	;//// Script-Scene #7 ////////////////////////////////////////////
	;//// CHECKERS ZOOM ////////////////////////////////////////////
	
checkers_part2:
	call checkers_zoom2
	
	;//// Script-Scene #8 ////////////////////////////////////////////
	;//// TWISTER ////////////////////////////////////////////////////

;-- initialize twister code --

	.equ	TWISTER_FRAMES,	-46*FPS + 4+2 ;boobie girl sync
	
twister_part:	
	;enable grey display mode

	call AV_CLRVRAM		;clear all vram
	mov	r1,IRAM_DSPMODE	
	mov	@r1,DM_GREY

	mov	a,SC_MSG06 & $FF
	mov r1,SM_MOVEON+SM_SINEOFF+16
	call initscrolly
	
	mov	a,TWISTER_FRAMES & $FF
	mov	r1,TWISTER_FRAMES >> 8
	call AV_SETTRIGGER2
	
	;clear twister vars
	
	mov r1,IRAM_TWISTSTEP 
	mov r2,4		
twistres:	
	mov @r1,0		
	inc r1
	djnz r2,twistres
	mov	r7,8				;stretch/schrink speed
	
twisterloop:
;-- show twister --
	;------------------------
	call cls
	sel	mb1
	call twister
	sel	mb0
	call showscrolly
	call AV_SHOW_WITHSCROLL
	jc twisterloop
	
	;//// Script-Scene #9 ////////////////////////////////////////////
	;//// 3D OBJECTS /////////////////////////////////////////////////

.equ	OBJECTS_FRAMES, -19*FPS	
.equ	OBJECTS_SCROLLY_FRAMES,-OBJECTS_FRAMES-112 ;7.5*FPS	
.equ	OBJECTS_SPIN_FRAMES, -OBJECTS_FRAMES-5*FPS	

meshinit:
	call AV_CLRVRAM
	sel	mb1	
	call rnd_setseed
	call set_mesh_verts

	mov r1,9*4		;1st star vert
	mov r7,30		;number of stars
lll3:
	sel	mb0
	call mz_resetstars	;call reset_star
	;sel mb0			;djnz r7,lll3
	
	mov	a,SC_MSG02 & $FF
	mov	r1,SM_MOVEOFF+SM_SINEON+27
	call initscrolly
	
	mov a,pyramid_lines & $ff
	call meshsub
	mov a,cube_lines & $ff
	call meshsub
	clr a						;for ship mov a,ship_lines & $ff
	;mov	r2,OBJECTS_SHIP_FRAMES & $FF
	;mov	r1,OBJECTS_SHIP_FRAMES >> 8
	call meshsub ;ship	
	jmp bg_code

;;//// commonly used by main loop and mega-zoomer //////////////

	; r1 = x-start, r2 = y-start
	
init_dndn_stars:
	; Starfield init code	
	mov	a, XVRAM1
	outl	p1,a
	;anl p1,XVRAM1
	mov r0,0	; set centre
	mov a,25	;r1
	movx @r0,a
	inc r0
	clr	a
	movx @r0,a
	inc r0
	mov a,20	;r2
	movx @r0,a
	inc r0
	clr	a
	movx @r0,a

	mov r1,4		;1st vert
	mov r7,30		;30 stars
	
mz_resetstars:
	sel mb1
mz_starloop:
	call reset_star
	djnz r7, mz_starloop
	sel mb0
	ret

	
mz_init_mega:		
	mov r7, <megalogo		; select the megalogo	
mz_init:	
	mov	r0, M_PLAY_CTR		;m player heartbeat
	mov	a,@r0
	jb0 playfix				;save to skip the non play frame
	call AV_SHOW			;sound frame must be played 
	;jmp  mz_init			;try again
playfix:	
	mov	r0, M_PLAY_CTR		;skip even sound frame to keep audio in line
	call M_PLAY_END			;for code that takes more then 1 fram
	sel mb1
	call mz_create_luts		; create look-up tables, returns in rb0
	sel rb1					; back to rb1: logo-offset is in r7
	call mz_unpacklogo		; copy unpacked logo to XRAM
	sel mb0
	ret

meshsub:	
	mov	r0,IRAM_3DOBJECT
	mov @r0,a				;save object
	mov	a,OBJECTS_FRAMES & $FF
	mov	r1,OBJECTS_FRAMES >> 8
	call AV_SETTRIGGER2
	call AV_SHOW_VRAM3
	mov	r1,IRAM_DSPMODE
	mov	@r1,DM_BLEED
meshloop:
	call AV_CLS_VRAM3
	anl	p1,XVRAM1
	
	mov	r2,<OBJECTS_SPIN_FRAMES
	mov	r1,>OBJECTS_SPIN_FRAMES
	call AV_TESTTRIGGER2
	jnc meshnospin
	
	mov r0,transform_spin
	mov @r0,$39
	mov r1,4	; first vert (0 = centre of effect)
	mov a,6		; verts to transform
	sel mb1
	call transform
	sel	mb0
	
meshnospin:	
	mov r1,IRAM_3DOBJECT
	mov a,@r1
	jnz objshw
	
	mov	r2,<OBJECTS_SCROLLY_FRAMES
	mov	r1,>OBJECTS_SCROLLY_FRAMES
	call AV_TESTTRIGGER2
	jnc meshnoscr
	
	orl	p1,XVRAM3
	call showscrolly
	anl	p1,XVRAM1
	
meshnoscr:
	;add stars for spaceship
	
	mov r1,transform_spin
	mov @r1,$00
	mov r1,9*4				;1st star vert
	mov a,10				;number of stars
	sel mb1
	call transform
	mov r6,10				;number of stars
	mov r1,9*4				;1st star vert
	call draw_starfield
	
	;draw space ship
	mov a,ship_lines & $ff
	
objshw:
	sel mb1
	call draw_mesh
	sel mb0
	orl p1,XVRAM3
	call AV_SHOW_WITHSCROLL
	jc meshloop
	jmp AV_CLS				;clear object

	
	
	; duration settings of scene #6 and of the sequences within the scene
.equ mz_sc6_duration_all,	-33 * FPS 	; overall duration
.equ mz_sc6_duration_seq1,	27 * FPS	; seq1: stars: no rot, logo: y move
.equ mz_sc6_duration_seq2,	20 * FPS	; seq2: stars: rot r, logo: y move
.equ mz_sc6_duration_seq3,	13 * FPS	; seq3: stars: rot r, logo xy move
	
scene_6:
	
	; For a better visual experience it is important, that the
	; lenghty initialization of this scene is done *before*
	; the preceeding starfield in Scene #5 is started. This way,
	; we can achieve seemless transition of the pure starfield to
	; the integrated starfield plus zoomer part.
	
	; set effect parameters
	mov r0, IRAM_MZ_XPOS
	mov @r0, 4				; start x
	inc r0					; IRAM_MZ_YPOS
	mov @r0, 12				; start y

	; set various flags to zero, which leads to
	; allow (x|y) movement, allow (dx|dy) zoom, no delay
	clr a
	sel mb1
	call scene_6_set_some_parameters	; expects a to be zero
	sel mb0

	mov @r0, 1				; have stars
	inc r0					; MZ_SHOW_CR
	mov @r0, a				; show CODE RED logo and the end of the sequence

	mov	a,  mz_sc6_duration_all & $FF
	mov r1, mz_sc6_duration_all >> 8
	call AV_SETTRIGGER2
	jmp mz_run2
	
	
	;//// BOOBIEGIRL ///////////////////////////////////////////
	
bg_code:	
	.include "boobiegirl\bgcode.asm"	;boobiegirl main code
	
	;//// FINAL ////////////////////////////////////////////////
	
final:	

.ifdef LOOPDEMO				
	jmp  0					;loop for cartridge version
.endif
	
.ifndef LOOPDEMO
	mov a,$30				;end with explosion for video recording
	call AV_SOUND
	jmp	$		
.endif	
	;///////////////////////////////////////////////////////////

;----------------------------------------------
;TEXT 
;----------------------------------------------

;stored at page 3 for easier 256 byte looped text

	.org	$300		
	
	.include "text\text.asm"
	
;----------------------------------------------
; FONT graphics
;----------------------------------------------

	.org	$400		;page aligned

.equ	FONTWIDTH,	5	;width of character (exluding spacing)
	
	.include "font\font-poopie2b.asm"
	
fontdata:
	mov a,r6	;1
	inc r6		;1
	movp a,@a	;2
	ret			;2
	
	.include "checkers\checkers-zoom-part1.asm"
	.include "scrolly\scrolly-p1.asm"

;---------------------------------------	
;SCROLLY code
;---------------------------------------	

	.org	$500

	.include "scrolly\scrolly-p2.asm"
	
;---------------------------------------	
;SOUND data
;---------------------------------------	

	.org	$600
	
	.include "sound\mplay.asm"
	.include "checkers\checkers-zoom-part2.asm"

;---------------------------------------	
;boobiegirl compressed images 
;---------------------------------------	

	.org	$700
	
	.equ	BGDBANK,  $ >> 8	;bank holding dimmed images

	.include "includes\tablecode_bnp.asm"
	
	.include "boobiegirl\boobies1d.asm"	;dim images
	.include "boobiegirl\boobies2d.asm"
	.include "boobiegirl\boobies3d.asm"
	
	.include "includes\decompress_bnp.asm"
	
	.org	$800
	
	.equ	BGBBANK, $ >> 8		;bank holding bright images
	
	.include "boobiegirl\tablecode_bnp_mb0.asm"	

	.include "boobiegirl\boobies1b.asm"	;bright images
	.include "boobiegirl\boobies2b.asm"
	.include "boobiegirl\boobies3b.asm"
	
;---------------------------------------
;TWISTER 1/2
;---------------------------------------

	.org	$900
	
	.include	"twist\newbar32b.asm" 	;twister gfx data
	.include	"twist\twister-p1.asm"	;twister code

;---------------------------------------
;TWISTER 2/2
;---------------------------------------

	.org	$A00
	
	.include	"twist\newbar32d.asm"	;twister gfx data
	.include	"twist\twister-p2.asm"	;twister code
	.include    "mega-zoomer\filler_mb1_5bytes.asm"	; outsourced code

;---------------------------------------
	
	.org	$B00
	.include	"plot\plot.asm"
	.include	"plot\line.asm"
	.include	"plot\rand.asm"
	.include 	"mega-zoomer\div16.asm"	; mega-zoomer 16bit division
	.include	"mega-zoomer\seq.asm"	; mega-zoomer sequence code for scene #6
	.org	$C00
	.include	"plot\transform.asm"
	.include	"plot\stars.asm"
	.include	"plot\mesh.asm"
	
;***************************************************************
; CODE START: MEGA-ZOOMER
;***************************************************************

; MEGA-ZOOMER needs to be aligned with $D9A
.org $D9A								

.include "mega-zoomer\const.asm"
.include "mega-zoomer\artwork.asm"
.include "mega-zoomer\core.asm"
.include "mega-zoomer\drawstars.asm"
.include "mega-zoomer\filler_mb1_9bytes.asm"

;---------------------------------------
;THE END
;---------------------------------------

	.org	$1000	;END OF ROM