;== Adventure Vision 8048 micro controller include file v1.02 ==================

.ifndef MC8048_ASM
.set MC8048_ASM, 1

;Main registers (registerbank 0)

.equ	REG_RB0R0,	$00	;this register set is mainly used by BIOS routines
.equ	REG_RB0R1,	$01
.equ	REG_RB0R2,	$02
.equ	REG_RB0R3,	$03
.equ	REG_RB0R4,	$04
.equ	REG_RB0R5,	$05
.equ	REG_RB0R6,	$06
.equ	REG_RB0R7,	$07

;stackpointer

.equ	STACK,		$08 ;stack stored and increased on call, fetched and decreased on ret
.equ	STACKSIZE,	$10 ;8 stack entries
.equ	STACK0,		$08 ;first stack entry
.equ	STACK1,		$0A
.equ	STACK2,		$0C
.equ	STACK3,		$0E
.equ	STACK4,		$10
.equ	STACK5,		$12
.equ	STACK6,		$14
.equ	STACK7,		$16

;Alternative registers (registerbank 1)

.equ	REG_RB1R0,	$18	;register set mainly used for cartridge main program
.equ	REG_RB1R1,	$19
.equ	REG_RB1R2,	$1A
.equ	REG_RB1R3,	$1B
.equ	REG_RB1R4,	$1C
.equ	REG_RB1R5,	$1D
.equ	REG_RB1R6,	$1E
.equ	REG_RB1R7,	$1F

;general purpose internal RAM

.equ	IRAM,		$20
.equ	IRAM_20,	$20
.equ	IRAM_21,	$21
.equ	IRAM_22,	$22
.equ	IRAM_23,	$23
.equ	IRAM_24,	$24
.equ	IRAM_25,	$25
.equ	IRAM_26,	$26
.equ	IRAM_27,	$27
.equ	IRAM_28,	$28
.equ	IRAM_29,	$29
.equ	IRAM_2A,	$2A
.equ	IRAM_2B,	$2B
.equ	IRAM_2C,	$2C
.equ	IRAM_2D,	$2D
.equ	IRAM_2E,	$2E
.equ	IRAM_2F,	$2F
.equ	IRAM_30,	$30
.equ	IRAM_31,	$31
.equ	IRAM_32,	$32
.equ	IRAM_33,	$33
.equ	IRAM_34,	$34
.equ	IRAM_35,	$35
.equ	IRAM_36,	$36
.equ	IRAM_37,	$37
.equ	IRAM_38,	$38
.equ	IRAM_39,	$39
.equ	IRAM_3A,	$3A
.equ	IRAM_3B,	$3B
.equ	IRAM_3C,	$3C
.equ	IRAM_3D,	$3D
.equ	IRAM_3E,	$3E
.equ	IRAM_3F,	$3F
.equ	IRAM_LAST,	$3F

.endif ;MC8048_ASM
;===============================================================================
