	; Adventure Vision Demo
	; * Mega Logo Zoomer 
	; by sy2002, Mar 23 2013
	
	; MEGA-ZOOMER CONSTANTS

; constants for easier embedding into existing code/frameworks

.equ CMZ_RAMCACHE_BANK, XVRAM0	; RAM cache for bitmap patterns: memory bank

.equ CMZ_RAMCACHE_OFFS, $00		; RAM cache for bitmap patterns: offset within bank
								; due to ROM optimizations: is now assumed to be zero
								
.equ CMZ_RATIOS_LUT_BANK, XVRAM2; RAM LUT bank

.equ CMZ_XRATIOS_LUT_OFFS, $00	; RAM LUT for precalculated width-ratios, 16bit values, hi/lo
								; due to ROM optimizations: is now assumed to be zero

;.equ CMZ_YRATIOS_LUT_OFFS, $CE	; RAM LUT for precalculated height-ratios, 16bit values, hi/lo
.equ CMZ_XRATIOS_LUT_START, 1	; Width-ratios: Smallest x-size
.equ CMZ_XRATIOS_LUT_END,	50	; Width-ratios: Biggest x-size
.equ CMZ_YRATIOS_LUT_START, 1	; Height-ratios: Smallest y-size
.equ CMZ_YRATIOS_LUT_END,   10	; Height-ratios: Biggest y-size

.equ CMZ_XRATIOS_SIZE, CMZ_XRATIOS_LUT_END - CMZ_XRATIOS_LUT_START + 1
.equ CMZ_YRATIOS_SIZE, CMZ_YRATIOS_LUT_END - CMZ_YRATIOS_LUT_START + 1
.equ CMZ_YRATIOS_LUT_OFFS, CMZ_XRATIOS_LUT_OFFS + (CMZ_XRATIOS_SIZE * 3)

.equ CMZ_ZOOMSLIDE_BANK, XVRAM2	; Y interpolation during the zoom-effect
.equ CMZ_ZOOMSLIDE_OFFS, CMZ_YRATIOS_LUT_OFFS + (CMZ_YRATIOS_SIZE * 3)

; while running, this effect uses the following variables in internal RAM
; IMPORTANT: BYTE ORDER

.equ IRAM_MZ_LOCAL1, $20		; only used as local variable within functions
.equ IRAM_MZ_LOCAL2, $21		; only used as local variable within functions
.equ IRAM_MZ_LOCAL3, $22		; only used as local variable within functions
.equ IRAM_MZ_LOCAL4, $23		; only used as local variable within functions
.equ IRAM_MZ_LOCAL5, $24		; only used as local variable within functions
.equ IRAM_MZ_LOCAL6, $25		; only used as local variable within functions
.equ IRAM_MZ_LOCAL7, $26		; only used as local variable within functions
.equ IRAM_MZ_LOCAL8, $27		; only used as local variable within functions
.equ IRAM_MZ_LOCAL9, $28		; only used as local variable within functions
.equ IRAM_MZ_LOCAL10, $29		; only used as local variable within functions
.equ IRAM_MZ_LOCAL11, $31		; only used as local variable within functions
.equ IRAM_MZ_LOCAL12, $32		; only used as local variable within functions
.equ IRAM_MZ_LOCAL13, $33		; only used as local variable within functions
.equ IRAM_MZ_LOCAL14, $34		; only used as local variable within functions

; potentially dangerous due to scrolly, i.e. currently the Mega-Zoomer
; can not be displayed simulteneously with the scroller
; IMPORTANT: BYTE ORDER

.equ IRAM_MZ_LOCAL15, $35		; only used as local variable within functions
.equ IRAM_MZ_LOCAL16, $36		; only used as local variable within functions

; variables for the demoeffect
; IMPORTANT: BYTE ORDER

.equ IRAM_MZ_XPOS, $2A			; original x-pos of the logo (top/left corner)
.equ IRAM_MZ_YPOS, $2B			; original y-pos of the logo (top/left corner)
.equ IRAM_MZ_CIRCLE_X_IDX, $2C	; index of current x-position in the circle LUT
.equ IRAM_MZ_CIRCLE_Y_IDX, $2D	; index of current y-position in the circle LUT
.equ IRAM_MZ_ZOOMSLIDE, $2E		; current step in the zoomslide
.equ IRAM_MZ_ZOOMSLIDE_CNTR, $2F; counter for looping the zoomslide
.equ IRAM_MZ_ZOOMSLIDE_DIR, $30	; direction of movement: -1 = enlarge, 1 = shrink

; constants which affect the visual appearance

.equ CMZ_CIRCLE_START_X, $00	; initial start index for x
.equ CMZ_CIRCLE_START_Y, $18	; initial start index for y
