
;---------------------------------------
;16-bit division
;---------------------------------------

; R3.R2 = R3.R2 / R5.R4
; R1.A = R3.R2 modulo R5.R4
; R6 = 0

divide:
	mov	r6,16	;16 shifts
	clr	a	;clear result R1.A
	mov	r1,a
	;clr	c	
div16a:
	xch	a,r2	;R3.R2 << 1 + carry (result)
	rlc	a
	xch	a,r2
	xch	a,r3
	rlc	a
	xch	a,r3

	rlc	a	;R1.A << 1 + carry (modulo)
	xch	a,r1
	rlc	a
	xch	a,r1
	call	negate	;r1.a = r1.a - r5.r4
	add	a,r4	;R1.A = R1.A - R5.R4
	xch	a,r1
	addc	a,r5
	xch	a,r1
	call	negate	;r1.a = r1.a - r5.r4
        jc	div16b	;keep substraction
	
	add	a,r4	;R1.A = R1.A + R5.R4 restore
	xch	a,r1
	addc	a,r5
	xch	a,r1
	clr	c
div16b:	
	djnz	r6,div16a
	xch	a,r2	;R3.R2 << 1 + carry
	rlc	a
	xch	a,r2
	xch	a,r3
	rlc	a
	xch	a,r3
	ret

;-------------------------------	
;16-bit negate
;-------------------------------

;R5.R4 = -R5.R4

negate:
	xch	a,r4	
	cpl	a
	inc	a	;use inc instead of add to preserve carry
	jz	ngt1
ngt0:	
	xch	a,r4
	xch	a,r5
	cpl	a
	xch	a,r5
	ret
ngt1:	
	xch	a,r4
	xch	a,r5
	cpl	a
	inc	a
	xch	a,r5
	ret
	
