
rnd_setseed:
	mov	r0,rtab
	mov	@r0,$23
		inc r0
	mov	@r0,$FA
		inc r0
	mov	@r0,$56
		inc r0
	mov	@r0,$22
	ret

; Algorithm by EternityForest:
; http://www.electro-tech-online.com/general-electronics-chat/124249-ultra-fast-pseudorandom-number-generator-8-bit.html
rng:
; Uses r0 for addressing.
; Uses r1 for storage.
; Saves r1 in r3
; Return in a.
		mov  a,r1
		mov  r3,a
        mov  r0, rtab         ; Increase byte 1
        inc  @r0             ; Commit b1
        inc  r0              ; Adjust byte 2: b1 ^ b2 ^ b4
        mov  a, r0
        mov  r1, a           ; Store address to backup
        xrl  a, @r1          ; a ^= b2
        inc  r1              ; a ^= b3
        inc  r1              ; "
        xrl  a, @r1          ; "
        mov  @r0, a          ; Commit b2
        mov  r1, a           ; Store b2 for s4 calculation
        inc  r0              ; Adjust byte 3: b3 + b2
        add  a, @r0          ; "
        mov  @r0, a          ; Commit b3
        inc  r0              ; Adjust byte 4: b4 + (b3 >> 1) ^ b2
        rr   a               ; "
        xrl  a, r1           ; a ^= b2
        add  a, @r0          ; a += b4
        mov  @r0, a          ; Commit b4
		xch  a,r1			 ; restore r1 keeping a intact
		xch  a,r3
		xch  a,r1
        ret

.if 0	

; random dndn1011

rnd_setseed:
	ret
	mov	r0,rtab
	mov	@r0,$23
		inc r0
	mov	@r0,$FA
		inc r0
	mov	@r0,$56
		inc r0
	mov	@r0,$22
		inc r0
	ret

rnd:
	mov a,7
rnd2:	; clobbers a,r0,r2,r3
		; output in 6 bytes at rtab
		; use the first 4
		; pass in the number of loops
		; original algorithm used 20
	mov		r2,a
rnd1:
	mov		r0,rtab+3
	mov		a,@r0			;		move.b 	rtab+3,D1
	rrc		a				;		lsr.b 	#3,D1
	rrc		a				;
	rrc		a				;
	anl		a,$1f			;
	mov		r3,a
	mov		r0,rtab+5
	mov		a,@r0			;		move.b	rtab+5,D0
	xrl		a,r3			;		eor.b 	D0,D1
	rrc		a				;		roxr.b	#1,D1
							;		lea		rtab,A0
	mov		r0,rtab+1
	mov		a,@r0			;		roxl.w	(A0)+
	rlc		a
	mov		@r0,a
	dec		r0
	mov		a,@r0
	rlc		a
	mov		@r0,a

	mov		r0,rtab+3
	mov		a,@r0			;		roxl.w	(A0)+
	rlc		a
	mov		@r0,a
	dec		r0
	mov		a,@r0
	rlc		a
	mov		@r0,a

	mov		r0,rtab+5
	mov		a,@r0			;		roxl.w	(A0)+
	rlc		a
	mov		@r0,a
	dec		r0
	mov		a,@r0
	rlc		a
	mov		@r0,a

	djnz	r2,rnd1

	ret

.endif