;Adventure Vision scrolly v1.02 by MrBlinky March 2013
;===============================================================================

.ifndef SCROLLY_ASM
.set	SCROLLY_ASM, 1

.ifndef	CODERED_ASM

;IRAM usage

.equ	IRAM_CHCNT,			$34		;\character width counter
.equ	IRAM_PCHAR,			$35		;|pointer to current font character row
.equ	IRAM_PTEXT,			$36		;/pointer to current text character of message
.EQU	IRAM_SCROW, 		$37		;\scrolly display start row
.equ	IRAM_WTPOS,			$38		;|sine table pointer
.equ	IRAM_WTPSV,			$39		;/sine table pointer backup
.equ	IRAM_SCPOS,			$3A		;scrolly Y position
.endif

;Test code
;///////////////////

.ifndef	MEGABIOS_ASM		;no bios included asume standalone test
.set	SCROLLY_TEST, 1

	.include "includes\megabios.asm"
start:
	mov	r1,IRAM_DSPMODE	;rude set grey mode
	mov	@r1,DM_GREY	;set greymode

	call	initscrolly
	mov	r7,19		
mainloop:
	mov	r1,5		;1st screen
doscr:	
	call	frame	
	inc	r1
	mov	a,r1
	inc	r1		;next screen
	add	a,256-5-5	;test last screen
	jnc	doscr		;show next screen
	
	mov	r1,5+2
	call	frame
	jmp	mainloop	;start all over again
frame:
	mov	r2,2		;one frame of animation per 2 display frames
frml:
	mov	a,VRAMBANK3
	outl	p1,a		;bright pixels on odd banks
	call	copyscreen
	inc	r1
	anl	p1,$FE		;select greyscreen
	call	copyscreen
	dec	r1
	mov	a,r7
	add	a,256-7		;min 7
	jnc	flip
	add	a,256-26+7 	;max 26
	jnc	scrok
flip:	cpl	f1
scrok:	orl	p1,3
	mov	a,r7
	call	showscrolly	
	inc	r7
	jf1	frms
	dec	r7
	dec	r7
frms:	
	sel	rb0
	call	display
	sel	rb1
	djnz	r2,frml
	ret
	
;text	
;///////////////////	

	.org	$300
	
	.include "text\text.asm"	;note chars are pointers to font char data
	
; FONT graphics
;///////////////////

	.org	$400		;page aligned

.equ	FONTWIDTH,	5	;width of character (exluding spacing)
	
	.include "font\font-poopie2a.asm"
	
fontdata:
	mov a,r6	;1 font gfx ptr
	inc r6		;1
	movp a,@a	;2 get chr gfx
	ret			;2

;----------------------------------------------
	
	
.endif ;SCROLLY_TEST
;///////////////////

;---------------------------------------

;Tables
;---------------------------------------

shifttable: 
	
	.db	$00,$01,$03,$07,$0F,$1F,$3F,$7F ;table must be at page aligned
	
wavetable:
	;	0  0  1  1  2  3  4  5  5  6  6  6, 6, 6, 5, 5, 4, 3, 2, 1, 1, 0, 0  0 ;abs offset
	.db	0, 0, 1, 0, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0,-1, 0,-1,-1,-1,-1, 0,-1, 0, 0 ;rel offset
	
;----------------------------------------------------
;SHOW the scrolly part 2
;----------------------------------------------------
	
showscrolly_part2:	
	xrl a,@r0	;r2			
	rl a		
	swap a		;y byte offset
	anl a,$03
	add a,$06		;start vram
	
	;add start position

	mov	r1,IRAM_SCROW	;backup wave table pos
	add a,@r1			;display position
	mov	r0,a
	
	mov	a,@r1			;get scroll start row offset
	clr	f0				;	save register state on 1st pass
	add a,-5			;move one to left
	jnc $+4				;already most left 
	cpl f0				;don't save register state
	mov @r1,a			
	
	inc r1				;IRAM_WTPOS
	mov	a,@r1
	inc r1				;backup to IRAM_WTPSV
	mov @r1,a
	
	mov	r1,IRAM_CHCNT
	mov	a,@r1
	inc	r1			;IRAM_PCHAR
	mov	r5,a		;character counter
	mov	a,@r1
	inc	r1			;IRAM_PTEXT
	mov	r6,a		;font ptr
	mov	a,@r1
	mov	r7,a		;text ptr
	
scrollyloop:
	
	;continue same char
dochar:	
	mov	a,r5		;1
	dec	r5			;1 char pixel rows to go
    jb3 scrchar		;still doinge a char
	jb4 scrstep2	;2nd char
	jb5 scrstep3	;3rd char
	jb6 scrabort1	;end scrolly
	
	;step 1, get 1st char from word
scrstep1:	
	mov a,r7		;text pointer
	mov r5,$1C		;next step is step2
	movp3 a,@a
scrs2:	
	anl	a,$1F		;keep char bits
	mov	r6,a	
	rl a
	rl a
	add a,r6		;r6=5*char
	mov r6,a		;char gfx ptr
scrspc:	
	mov	r2,$FF		;  start with blank row
	jmp	scrlset
scrabort1:
    jb0 scrspc		;do one space row
 	jmp scrabort2	;end scrolly
	
scrstep2:
	;step 2 get 2nd char for word
	mov	a,r7
	inc	r7
	movp3 a,@a		;222----- 1st half of 2nd char bits
	swap a			;----222- 2nd char bits
	mov r5,a		;save them
	mov a,r7
	movp3 a,@a		;-22----- 2nd half of 2nd char bits
	rr a			;--22----
	xrl a,r5
	anl a,$F1		;mask of and join bits
	xrl a,r5
	rr a			;---22222 now 2nd char
	mov r5,$2C		;next step is step3
	jmp scrs2		;continue at step 1
	
	;step 3 get 3rd char from word
scrstep3:	
	mov a,r7		;text pointer
	inc r7			;next text word
	movp3 a,@a		;get char data
	rlc a			;end marker bit to carry
	rr  a
	mov r5,$0C		;next step is step1
	jnc scrs2		;continue scrolly
	mov r5,$4C		;next step is end of scrolly
	jmp scrs2		;continue at step 1 code
			
scrchar:
	call fontdata	;2+6 get font char data
	mov r2,a		;1 save data
	
	;save pointers for next scrolly call
scrlset:	
	jf0	yshift
	
	cpl	f0		
	mov	r1,IRAM_CHCNT
	mov	a,r5
	mov	@r1,a		;char counter and flags
	inc	r1
	mov	a,r6
	mov	@r1,a		;chr gfx ptr
	inc	r1
	mov	a,r7
	mov	@r1,a		;text pointer
	
	;shift char data
yshift:	
	mov	a,r3		;1 y-pos			
	mov	r1,a		;1 shift counter
	movp	a,@a		;1 get mask
	mov	r4,a		;1 LSB mask
	jb3	shiftx		;2 optimize shifts 4+ 
	jz	noshift 	;2 no shifts at all

	;1-3 shifts: shift left
	
	mov	a,r2		;1 get and shift data
shiftl:	rl	a		;1
	djnz	r1,shiftl	;2 
shiftok:	
	mov	r2,a		;1 save shifted data
noshift:
	;expand and update display
	
	movx	a,@r0		;2 read LSB display data	
	xrl	a,r2		;1 xor display data and shifted data
	anl	a,r4		;1 keep LSB display bits
	xrl	a,r2		;1 old display pixels and shift data
	movx	@r0,a		;2 store new display data
	inc	r0		;1
	movx	a,@r0		;2 get MSB display data
	xch	a,r2		;1 a=data, r1=display
	xrl	a,r2		;1 mix them
	anl	a,r4		;1 keep shifted data
	xrl	a,r2		;1 restore display bits and data
	movx	@r0,a		;2
	
	;get next vram pos

	mov	r1,IRAM_WTPOS
	mov	a,@r1
	jz	sclnext
	
	inc	@r1
	add	a,256-(wavetable & $FF)-23
	jnc	pstab1
	mov	@r1,wavetable & $FF
	
pstab1:
	mov	a,@r1		;IRAM_WTPOS
	movp a,@a
	add	a,r3		;y pos
	jb3	overflow
pstab2:	
	mov	r3,a
sclnext:	
	mov	a,r0		;1
	add	a,4			;1 next row
	mov	r0,a		;1
	jnc	scrollyloop	;2
	
	;end of scroll message jumps here
	
scrabort2:
	mov	r1,IRAM_WTPSV		;set next wave table pos
	mov	a,@r1				;IRAM_WTPOS
	dec r1	
	jz	sclmove				;no sine so end
	
	;set next sine pos
	
	add	a,23				;add offset
	mov	@r1,a				;update table position
	add	a,256-(wavetable & $FF)-24	;test wrap around
	jnc	sclmove				;no wrap
	add	a,wavetable & $FF	;fix table postion for wrap
	mov	@r1,a				;update table position
sclmove:
	mov r1,IRAM_SCPOS
	mov	a,@r1
	jb7	sclend				;auto move scrolly disabled

	;auto move up/down
	
	dec a					;move down
	jb6 scldown				;skip if moving down
	inc a					;correct above dec
	inc a					;move up
scldown:
	mov @r1,a				;store new pos
	add a,-SM_MAXYPOS-1
	jnz $+4
	mov @r1,$40+SM_MAXYPOS			;move down + max y pos
	add a,SM_MAXYPOS+1-SM_MINYPOS-$40
	jnz $+4
	mov @r1,SM_MINYPOS				;move up + max y pos
	
sclend:	
	sel	rb1		
	ret
	
overflow:
	jb7	underflow
	inc	r0
	inc	r0
underflow:	
	dec	r0
	anl	a,$07	
	jmp	pstab2
	
	;4 shifts: do swap (saves 9 cycles compared to doing rl a)
	
shiftx:
	jb4	shiftr		;2 not 4 shifts so do rr a
	mov a,r2		;1
	swap a			;1
	jmp shiftok		;2  
	
	;5-7 shifts: shift right
	
shiftr:
	mov	a,r1		;1
	xrl	a,$07		;2
	inc	a			;1
	mov	r1,a		;1
	mov	a,r2		;1
shrl:
	rr	a			;1
	djnz r1,shrl	;2  
	jmp	shiftok		;2 
	
;--------------------------------	

.endif ;SCROLLY_ASM
;===============================================================================