;   __  __ _____  _      ____ __  __
;  |  \/  || ()_)| |__  / () \\ \/ /
;  |_|\/|_||_|   |____|/__/\__\|__| 
;
;    ADVENTURE VISION MUSIC PLAYER
;
;  ******************************************
;  *  original music player (MPLAY) by pop  *
;  *  optimized nibble version by MrBlinky  *
;  *          music by Skyrunner            *
;  *           AV devteam  2013             *
;  ******************************************

;=========================================================================

.ifndef	CODERED_ASM

.equ	M_SONG_POS,		$39	;song position       \  do not changer order
.equ	M_PLAY_CTR,		$3A	;global state counter/ 
.equ    M_PLAY_CMD,		$3B

.endif

;song and pattern tables
;---------------------------------------

	;note song data must be 256 byte aligned
	
SONG_DATA:
	;old song table
	;.db	0,0,0,0,0,0,1,2,3,2,3,4,5,5,6,2,3,2,3,4,5,5,1
	;.db	-1

	;new nibble song table
	.db	M_PATTERN0 + (M_PATTERN1 << 4) ;0
	.db	M_PATTERN0 + (M_PATTERN1 << 4) ;0
	.db	M_PATTERN0 + (M_PATTERN1 << 4) ;0
	.db	M_PATTERN0 + (M_PATTERN1 << 4) ;0
	.db	M_PATTERN0 + (M_PATTERN1 << 4) ;0
	.db	M_PATTERN0 + (M_PATTERN1 << 4) ;0
	.db	M_PATTERN2 + (M_PATTERN3 << 4) ;1
	.db	M_PATTERN4 + (M_PATTERN5 << 4) ;2
	.db	M_PATTERN6 + (M_PATTERN5 << 4) ;3
	.db	M_PATTERN4 + (M_PATTERN5 << 4) ;2
	.db	M_PATTERN6 + (M_PATTERN5 << 4) ;3
	.db	M_PATTERN4 + (M_PATTERN2 << 4) ;4
	.db	M_PATTERN7 + (M_PATTERN2 << 4) ;5
	.db	M_PATTERN7 + (M_PATTERN2 << 4) ;5
	.db	M_PATTERN7 + (M_PATTERN8 << 4) ;6
	.db	M_PATTERN4 + (M_PATTERN5 << 4) ;2
	.db	M_PATTERN6 + (M_PATTERN5 << 4) ;3
	.db	M_PATTERN4 + (M_PATTERN5 << 4) ;2
	.db	M_PATTERN6 + (M_PATTERN5 << 4) ;3
	.db	M_PATTERN4 + (M_PATTERN2 << 4) ;4
	.db	M_PATTERN7 + (M_PATTERN2 << 4) ;5
	.db	M_PATTERN7 + (M_PATTERN2 << 4) ;5
	.db	M_PATTERN2 + (M_PATTERN3 << 4) ;1
	.db	$FF

;optimized 16 byte pattern tables (old ones where 32 bytes)

.equ	PATTERN_DATA, $ & $FF

.equ	M_PATTERN0,0
	.db	$a0,$00,$08,$10,$03,$08,$a7,$a3 ;0
	.db	$a0,$00,$ac,$08,$03,$1c,$a0,$00
.equ	M_PATTERN1,1
	.db	$a7,$00,$a8,$08,$03,$18,$aa,$a7
	.db	$a8,$08,$a0,$a5,$03,$08,$a5,$a3
	
.equ	M_PATTERN2,2	
	.db	$a5,$00,$08,$15,$03,$08,$a5,$00 ;1
	.db	$a8,$a7,$08,$17,$03,$a7,$a8,$08
.equ	M_PATTERN3,3
	.db	$ac,$00,$00,$1a,$00,$00,$a5,$00
	.db	$a8,$00,$00,$a7,$00,$00,$a3,$00
	
.equ	M_PATTERN4,4	
	.db	$a0,$00,$08,$10,$03,$00,$08,$08 ;2
	.db	$a0,$00,$a7,$08,$03,$ac,$a3,$00
.equ	M_PATTERN5,5
	.db	$a0,$00,$08,$10,$03,$00,$08,$08
	.db	$a3,$00,$a2,$a3,$03,$13,$a2,$00
	
.equ	M_PATTERN6,6	
	.db	$a0,$00,$08,$10,$03,$00,$08,$08 ;3
	.db	$a0,$00,$a2,$a3,$03,$ac,$a3,$00
	;repeat of M_PATTERN5
	;	$a0,$00,$08,$10,$03,$00,$08,$08 
	;	$a3,$00,$a2,$a3,$03,$13,$a2,$00 
	
	;repeat of M_PATTERN4
	;	$a0,$00,$08,$10,$03,$00,$08,$08 ;4 
	;	$a0,$00,$a7,$08,$03,$ac,$a3,$00 
	;repeat of M_PATTERN2
	;	$a5,$00,$08,$15,$03,$08,$a5,$00 
	;	$a8,$a7,$08,$17,$03,$a7,$a8,$08 
	
.equ	M_PATTERN7,7	
	.db	$a5,$00,$08,$15,$03,$00,$08,$08 ;5
	.db	$a5,$00,$ac,$08,$03,$af,$a8,$00
	;repeat of M_PATTERN2
	;	$a5,$00,$08,$15,$03,$08,$a5,$00
	;	$a8,$a7,$08,$17,$03,$a7,$a8,$08 
	
	;repeat of M_PATTERN7
	;	$a5,$00,$08,$15,$03,$00,$08,$08 ;6
	;	$a5,$00,$ac,$08,$03,$af,$a8,$00 
.equ	M_PATTERN8,8
	.db	$ac,$00,$08,$1a,$03,$08,$a5,$00
	.db	$a8,$00,$08,$a7,$03,$08,$a3,$03

;mplayer code
;---------------------------------------

M_PLAY: 
	mov	r0,M_PLAY_CTR		;sound frame counter
	mov	a,@r0
	;jb0	M_PLAY_NUL
	jb0 M_PLAY_END
	dec	r0			;M_SONG_POS
	jb5	M_PLAY_ODD
	
	;for even patterns
	
M_PLAY_EVEN:	
	mov	a,@r0		;get song pos
	movp	a,@a		;get pattern from song table
	swap	a		;*16
	inc	a		;test end of song table (2x PATTERN-F)
	jnz	M_PLAY_NOWRAP	
	
	mov	@r0,a		;set song start
	jmp	M_PLAY_EVEN
M_PLAY_ODD:
	mov	a,@r0		;get song pos
	movp	a,@a		;get pattern from song table
	;jmp	M_PLAY_NOWRAP	;continue			
	
M_PLAY_NOWRAP:
	anl	a,$F0		;get pattern table start
	inc	r0		;M_PLAY_CTR
	rl	a		;
	xrl	a,@r0		;xor counter for pattern pos
	anl	a,$E1		;keep xored pattern table bits
	xrl	a,@r0		;restore pattern table bits and or in pattern pos
	rr	a		;pattern data offset
	add	a,PATTERN_DATA	;pattern data address
	movp	a,@a		;get music data
	mov	r1,a		;save it for now
	swap	a		;sound command type to low nibble
	anl	a,$0f		;test note or sound fx
	jnz	M_DO_NOTE	;it is a note
	call	AV_SOUND	;silence sound command
	mov	a,r1		;get sound effect 
	swap	a		;to sound effect command
	jmp	M_SET_2ND
M_DO_NOTE:
	call	AV_SOUND	;note effect
	mov	a,r1		;music data	
	orl	a,$f0		;make note sound command
M_SET_2ND:

;	inc r0			;mov r1,M_PLAY_CMD
;	mov	@r0,a
;	dec r0
	mov	r1,$C0		;$FF shorter delay
	djnz	r1,$		;perform delay to allow COP411 to process sound command
	call	AV_SOUND
	
M_PLAY_END:
	;mov	r0,M_PLAY_CTR		;increment sound frame counter
	mov	a,@r0
	inc	a
	anl	a,$3F
	mov	@r0,a
	jnz	M_PLAY_SAMEPOS
	dec	r0			;next song pos
	inc	@r0		
M_PLAY_SAMEPOS:	
	ret
;M_PLAY_NUL:
;    clr a
;	jmp	M_SET_2ND


;;-------------old
;M_PLAY_1:
;	;mov	r0,FLAG_BYTE		;play on 2nd frame
;	mov	r0,IRAM_FRAMES
;	mov	a,@r0
;	jb0	M_PLAY_END_1
;	
;M_PLAY_NOW_1:
;	mov	r0,M_SONG_POS		;song pointer
;	mov	a,@r0
;	call	M_READ_SONG		;returns pattern # in A
;	mov	r1,a			;store pattern offset
;	inc	a
;	jnz	M_NO_WRAP		;check for -1 (song end)
;	
;	mov	@r0,4 ;a		;reset song (a=0) > loop song to pattern 4
;	mov	r1,a
;	call	M_READ_SONG		;read again
;	jmp	M_WRAPPED
;
;M_DO_NOTE:
;	call	AV_SOUND		;write to cop411
;	mov	a,r3			;restore A	
;	orl	a,$f0			;remove high nibble and..
;	;mov	@r0,a			;store A safely
;	mov	r3,a
;	jmp M_PLAY_END_1
;	
;M_NO_WRAP:
;	mov	a,r1
;M_WRAPPED:
;	swap	a			;shift 5 bits left for..
;	rl	a			;..patterns of 32 notes
;	mov	r1,a			;store pattern offset
;	dec	r0	;mov	r0,M_PATTERN_POS	;note pointer
;	mov	a,@r0
;	inc	@r0
;	add	a,r1			;add pattern offset
;	call	M_READ_NOTE		;returns value in A
;	;mov	r0,M_NOTE_STORE
;	mov	r3,a			;backup A
;	swap	a
;	anl	a,$0f			;remove high nibble
;	jnz	M_DO_NOTE		;is it a note?
;	call	AV_SOUND		;write to cop411
;	inc	r0 ;M_SONG_POS
;	mov	a,-4			;1st 4 patterns have no sfx
;	add	a,@r0
;	clr	a			
;	jnc	M_PLAY_END_1-1
;	
;	mov	a,r3			;restore A
;	swap	a			;address sound fx
;	;mov	@r0,a			;store A safely
;	mov	r3,a
;M_PLAY_END_1:	
;	;ret
;	
;	mov	r1,$ff			;wait for cop411 to finish
;delay:	djnz	r1,delay		;put your own code here
;
;M_PLAY_2:
;	;mov	r0,FLAG_BYTE		;play on 2nd frame
;	;mov	a,@r0
;	;xrl	a,%00000001		;MPLAY uses this bit!
;	;mov	@r0,a
;	;jz	M_PLAY_END_2
;	
;	mov	r0,IRAM_FRAMES
;	mov	a,@r0
;	rrc	a
;	jc	M_PLAY_END_2
;	
;M_PLAY_NOW_2:
;	;mov	r0,M_NOTE_STORE
;	;mov	a,@r0
;	mov	a,r3
;	call	AV_SOUND		;play note or sfx
;	mov	r1,M_PATTERN_POS
;	mov	a,@r1
;	jb5	M_NEXT_PATTERN		;32 notes played?
;	ret
;M_NEXT_PATTERN:
;	mov	@r1,0			;reset note pointer
;	inc	r1			;M_SONG_POS
;	inc	@r1			;next pattern of song
;M_PLAY_END_2:
;	ret
;-------------------------------------------------------------------------
