;Adventure Vision twister v1.14 page 1 of 2 by MrBlinky March 2013
;===============================================================================

;- IRAM vars -

.ifndef	CODERED_ASM

.equ	IRAM_TWISTSTEP,		$30	;\
.equ	IRAM_TWISTPOS,		$31	; | do not change order
.equ	IRAM_TWISTSTEPH,	$32	; |
.equ	IRAM_TWISTPOSH,		$33	;/

.endif

;- constants -

.equ	STEP,	$20		;schrink/strectch speed
.equ	MAX,	3		;schrink/strectch range

.equ	TWIST_HEIGHT,	36	;height of twist image


twister:

;-- twist code --

	;shrink or stretch twist
	
	mov	r0,IRAM_TWISTSTEP
	mov	r1,IRAM_TWISTSTEPH
	mov	a,r7
	jb0	twistneg
twistpos:	
	mov	a,@r0
	add	a,STEP
	mov	@r0,a
	jnc	skiptoggle
	mov	a,@r1
	inc	a
	mov	@r1,a
	xrl	a,MAX		;check limit
	jmp	testtoggle
twistneg:
	mov	a,@r0
	add	a,-STEP
	mov	@r0,a
	jc	skiptoggle
	mov	a,@r1
	dec	a
	mov	@r1,a
	xrl	a,$FF-MAX	
testtoggle:	
	jnz	skiptoggle
	inc	r7
skiptoggle:
	
	;backup iram, we'll use it as fast display buffer
	
	anl	p1,$FC		;vram bank 0
	mov	r1,IRAM_20	;backup IRAM
	mov	r0,$20
iram2vram:	
	mov	a,@r1
	movx	@r0,a
	inc	r1
	djnz	r0,iram2vram
	orl	p1,$03		;vram bank 3

	;get twist pos
	
	mov	r0,IRAM_TWISTSTEP
	mov	a,@r0
	inc	r0
	mov	r1,a		;step lo
	mov	a,@r0	
	inc	r0
	mov	r2,a		;pos lo
	mov	a,@r0	
	inc	r0	
	mov	r3,a		;step high
	mov	a,@r0	
	mov	r4,a		;pos high

	sel	rb0
	mov	r0,$37		;display top col on row 9
	mov	r6,5		;5 vertical display columns
do5v:	
	sel	rb1		;save twist position for dim display buffer
	mov	a,r2
	mov	r5,a
	mov	a,r4
	mov	r6,a
	sel	rb0
	mov	r5,8		;8 pixels per vertical display column
do8v:
	rl	a		;get twister gfx ROM offset
	rl	a	
	mov	r2,a		
	mov	r4,4		;4 bytes per horizontal twist row
	mov	r1,IRAM_20	;start display buffer
do4h:			
	mov	a,r2
	movp	a,@a		;get 8 horizotal bright pixels
	mov	r3,8		;8 horizontal twister pixels 
do8h:	
	rlc	a		;twist pixel to carry
	xch	a,@r1		;save remaining twister pixels, fetch display buffer pixels
	rlc	a		;twist pixel to display buffer
	xch	a,@r1		;fetch remaining twister pixels,save display buffer pixels
	inc	r1		;next display buffer address
	djnz	r3,do8h		
nxt4h:	
	inc	r2		;next horizontal twitster gfx byte
	djnz	r4,do4h		;loop 4 times doing 32 pixels in total
	
	;get next twister gfx position
	
	call	twistnextpos
	
	;next vertical pixel 
	
	djnz	r5,do8v		;loop for 8 vertical pixels

	;display buffer full, copy to display
	
twistcopyd:	
	call	twistcopy
	in	a,p1
	xrl	a,$01		;toggle dim/bright bank
	outl	p1,a
	jb0	nxt5v		;dim display buffer done, do next bright
	
	jmp	dodim		;continue at dim pixels
nxt5v:	
	djnz	r6,do5v		;loop for 5 vertical columns

	jmp	twistcont
	
;===============================================================================