;Adventure Vision twister v1.14 page 2 of 2 by MrBlinky March 2013
;===============================================================================

;-- copy display buffer to display --
	
twistcopy:
	mov	r1,IRAM_20
	mov	r2,$20		;size of display buffer
twistcpy:	
	mov	a,@r1
	movx	@r0,a
	inc	r1
	mov	a,r0
	add	a,5
	mov	r0,a
	djnz	r2,twistcpy
	add	a,256-160-1	;back to start and one display column down
	mov	r0,a
	ret
	
;-- get twister next pos --
	
twistnextpos:
	sel	rb1
	mov	a,r1
	add	a,r2
	mov	r2,a
	mov	a,r3
	addc	a,r4
	jb7	twistwrp
	add	a,256-TWIST_HEIGHT
	jc	twistwrap
twistwrp:	
	add	a,TWIST_HEIGHT
twistwrap:
	mov	r4,a
	sel	rb0
	ret

;-- do dim display buffer --	

dodim:
	inc	r0		;point back to same display column
	sel	rb1		;get twist pos for dim display buffer
	mov	a,r5
	mov	r2,a
	mov	a,r6
	mov	r4,a
	sel	rb0
	mov	r5,8		;8 pixels per vertical display column
do8vd:
	rl	a		;get twister gfx ROM offset
	rl	a	
	mov	r2,a		
	mov	r4,4		;4 bytes per horizontal twist row
	mov	r1,IRAM_20	;start display buffer
do4hd:			
	mov	a,r2
	movp	a,@a		;get 8 horizotal bright pixels
	mov	r3,8		;8 horizontal twister pixels 
do8hd:	
	rlc	a		;twist pixel to carry
	xch	a,@r1		;save remaining twister pixels, fetch display buffer pixels
	rlc	a		;twist pixel to display buffer
	xch	a,@r1		;fetch remaining twister pixels,save display buffer pixels
	inc	r1		;next display buffer address
	djnz	r3,do8hd		
nxt4hd:	
	inc	r2		;next horizontal twitster gfx byte
	djnz	r4,do4hd	;loop 4 times doing 32 pixels in total
	
	;get next twister gfx position
	
	call	twistnextpos
	
	;next vertical pixel 
	
	djnz	r5,do8vd	;loop for 8 vertical pixels
	jmp	twistcopyd	;dim display buffer to display

;-- restore regs and iram --

twistcont:
	sel	rb1
	anl	p1,$FC		;vram bank 0
	mov	r1,IRAM_20	;backup IRAM
	mov	r0,$20	
vram2iram:	
	movx	a,@r0
	mov	@r1,a
	inc	r1
	djnz	r0,vram2iram
	orl	p1,$03		;vram bank 3
	
	;advance twist frame position
	
	mov	r1,IRAM_TWISTSTEPH ;TWISTPOSH
	mov	a,@r1
	inc	r1
	rlc	a		;test sign
	mov	a,r7
	jb3	$+3
	cpl	a		;simulate descending speed
	rr	a
	anl	a,$03
	;jnc	$+3
	;cpl	a
	;inc	a
	add	a,@r1
	jb7	twistwrp2
	add	a,256-TWIST_HEIGHT
	jc	twistwrap2
twistwrp2:		
	add	a,TWIST_HEIGHT
twistwrap2:
	mov	@r1,a		;update position
	ret	